{-# LANGUAGE MagicHash #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}

module Curry_Directory (d_C_doesFileExist, d_C_doesDirectoryExist, d_C_fileSize, d_C_getModificationTime, d_C_setCurrentDirectory, d_C_getDirectoryContents, d_C_createDirectory, d_C_removeFile, d_C_removeDirectory, d_C_renameFile, d_C_renameDirectory, d_C_getCurrentDirectory) where

import Basics
import qualified Curry_Prelude
import qualified Curry_Time
import System.Directory
import System.IO
import System.Time

import qualified Curry_Prelude as CP


d_C_doesFileExist :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_C_doesFileExist x1 x3500 = Curry_Prelude.d_OP_dollar_hash_hash d_C_prim_doesFileExist x1 x3500

d_C_doesDirectoryExist :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_C_doesDirectoryExist x1 x3500 = Curry_Prelude.d_OP_dollar_hash_hash d_C_prim_doesDirectoryExist x1 x3500

d_C_fileSize :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Int
d_C_fileSize x1 x3500 = Curry_Prelude.d_OP_dollar_hash_hash d_C_prim_fileSize x1 x3500

d_C_getModificationTime :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.C_IO Curry_Time.C_ClockTime
d_C_getModificationTime x1 x3500 = Curry_Prelude.d_OP_dollar_hash_hash d_C_prim_getModificationTime x1 x3500

d_C_setCurrentDirectory :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_setCurrentDirectory x1 x3500 = Curry_Prelude.d_OP_dollar_hash_hash d_C_prim_setCurrentDirectory x1 x3500

d_C_getDirectoryContents :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_getDirectoryContents x1 x3500 = Curry_Prelude.d_OP_dollar_hash_hash d_C_prim_getDirectoryContents x1 x3500

d_C_createDirectory :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_createDirectory x1 x3500 = Curry_Prelude.d_OP_dollar_hash_hash d_C_prim_createDirectory x1 x3500

d_C_removeFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_removeFile x1 x3500 = Curry_Prelude.d_OP_dollar_hash_hash d_C_prim_removeFile x1 x3500

d_C_removeDirectory :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_removeDirectory x1 x3500 = Curry_Prelude.d_OP_dollar_hash_hash d_C_prim_removeDirectory x1 x3500

d_C_renameFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_renameFile x1 x2 x3500 = Curry_Prelude.d_OP_dollar_hash_hash (Curry_Prelude.d_OP_dollar_hash_hash (acceptCs id d_C_prim_renameFile) x1 x3500) x2 x3500

d_C_renameDirectory :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_renameDirectory x1 x2 x3500 = Curry_Prelude.d_OP_dollar_hash_hash (Curry_Prelude.d_OP_dollar_hash_hash (acceptCs id d_C_prim_renameDirectory) x1 x3500) x2 x3500

d_C_prim_doesFileExist :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_C_prim_doesFileExist x1 x3500 = external_d_C_prim_doesFileExist x1 x3500

d_C_prim_doesDirectoryExist :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Bool
d_C_prim_doesDirectoryExist x1 x3500 = external_d_C_prim_doesDirectoryExist x1 x3500

d_C_prim_fileSize :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.C_Int
d_C_prim_fileSize x1 x3500 = external_d_C_prim_fileSize x1 x3500

d_C_prim_getModificationTime :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.C_IO Curry_Time.C_ClockTime
d_C_prim_getModificationTime x1 x3500 = external_d_C_prim_getModificationTime x1 x3500

d_C_getCurrentDirectory :: ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_getCurrentDirectory x3500 = external_d_C_getCurrentDirectory x3500

d_C_prim_setCurrentDirectory :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_prim_setCurrentDirectory x1 x3500 = external_d_C_prim_setCurrentDirectory x1 x3500

d_C_prim_getDirectoryContents :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_prim_getDirectoryContents x1 x3500 = external_d_C_prim_getDirectoryContents x1 x3500

d_C_prim_createDirectory :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_prim_createDirectory x1 x3500 = external_d_C_prim_createDirectory x1 x3500

d_C_prim_removeFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_prim_removeFile x1 x3500 = external_d_C_prim_removeFile x1 x3500

d_C_prim_removeDirectory :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_prim_removeDirectory x1 x3500 = external_d_C_prim_removeDirectory x1 x3500

d_C_prim_renameFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_prim_renameFile x1 x2 x3500 = external_d_C_prim_renameFile x1 x2 x3500

d_C_prim_renameDirectory :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C_prim_renameDirectory x1 x2 x3500 = external_d_C_prim_renameDirectory x1 x2 x3500
external_d_C_prim_doesFileExist :: CP.C_String -> ConstStore -> CP.C_IO CP.C_Bool
external_d_C_prim_doesFileExist s _ = toCurry doesFileExist s

external_d_C_prim_doesDirectoryExist :: CP.C_String -> ConstStore -> CP.C_IO CP.C_Bool
external_d_C_prim_doesDirectoryExist s _ = toCurry doesDirectoryExist s

external_d_C_prim_fileSize :: CP.C_String -> ConstStore -> CP.C_IO CP.C_Int
external_d_C_prim_fileSize s _ = toCurry
  (\f -> do h <- openFile f ReadMode
            i <- hFileSize h
            hClose h
            return i
  ) s

external_d_C_prim_getModificationTime :: CP.C_String -> ConstStore
                                      -> CP.C_IO Curry_Time.C_ClockTime
external_d_C_prim_getModificationTime s _ = toCurry getModificationTime s

external_d_C_getCurrentDirectory :: ConstStore -> CP.C_IO (CP.C_String)
external_d_C_getCurrentDirectory _ = toCurry getCurrentDirectory

external_d_C_prim_setCurrentDirectory :: CP.C_String -> ConstStore -> CP.C_IO CP.OP_Unit
external_d_C_prim_setCurrentDirectory s _ = toCurry setCurrentDirectory s

external_d_C_prim_getDirectoryContents :: CP.C_String -> ConstStore
                                       -> CP.C_IO (CP.OP_List (CP.C_String))
external_d_C_prim_getDirectoryContents s _ = toCurry getDirectoryContents s

external_d_C_prim_createDirectory :: CP.C_String -> ConstStore -> CP.C_IO CP.OP_Unit
external_d_C_prim_createDirectory s _ = toCurry createDirectory s

external_d_C_prim_removeFile :: CP.C_String -> ConstStore -> CP.C_IO CP.OP_Unit
external_d_C_prim_removeFile s _ = toCurry removeFile s

external_d_C_prim_removeDirectory :: CP.C_String -> ConstStore -> CP.C_IO CP.OP_Unit
external_d_C_prim_removeDirectory s _ = toCurry removeDirectory s

external_d_C_prim_renameFile :: CP.C_String -> CP.C_String
                             -> ConstStore -> CP.C_IO CP.OP_Unit
external_d_C_prim_renameFile s1 s2 _ = toCurry renameFile s1 s2

external_d_C_prim_renameDirectory :: CP.C_String -> CP.C_String
                                  -> ConstStore -> CP.C_IO CP.OP_Unit
external_d_C_prim_renameDirectory s1 s2 _ = toCurry renameDirectory s1 s2

